/* $Id: stubs.c 809 2008-06-12 22:01:45Z gerd $
 * ----------------------------------------------------------------------
 * Copyright 2008 by Gerd Stolpmann.
 *
 * This file is part of godi-tools.
 *
 * godi-tools is free software; you can redistribute it and/or modify it
 * under the conditions in the file LICENSE.
 *
 * godi-tools is distributed WITHOUT ANY WARRANTY, as detailed in the
 * file LICENSE.
 */

#include "sha1.h"
#include "mlvalues.h"
#include "alloc.h"

/* For simplicity, we statically allocate the SHA1_CTX. Thus, this module
   is not thread-safe
*/

SHA1_CTX ctx;

value sha1_init(value dummy) {
    SHA1Init(&ctx);
    return Val_unit;
}


value sha1_update(value s, value n) {
    int m;
    m = caml_string_length(s);
    if (Int_val(n) < m) m = Int_val(n);
    SHA1Update(&ctx, (unsigned char *) String_val(s), m);
    return Val_unit;
}


value sha1_final(value dummy) {
    value r;
    int k;
    unsigned char digest[20];
    SHA1Final(digest, &ctx);
    r = caml_alloc_string(20);
    for (k=0; k<20; k++)
	Byte_u(r,k) = digest[k];
    return r;
}
